SystemOrganization addCategory: 'OrbeonBPMXpdl'!

!XPDLParticipantNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/31/2015 16:24'!
createBpmDefinition

	^(self getType = 'ROLE')
		ifTrue: [BpmRoleParticipantDefinition new name: self getName] 
		ifFalse:  [BpmResourceParticipantDefinition new name: self getName]! !

!XPDLStartNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/28/2015 12:18'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition startEvent! !

!XPDLStartNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:28'!
getCycleComponentDefinitionClass

	^BpmStartComponentDefinition! !

Exception subclass: #OrbeonXpdlException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl'!

OrbeonXpdlException subclass: #ProcessAppMappingException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl'!

!XPDLIntermediateNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/05/2017 11:30'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getIntermediateEventNamed: self getName ifNone: [nil]! !

!XPDLIntermediateNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:26'!
getBpmTagComponentDefinitionClass

	^BpmNormalTagComponentDefinition! !

!XPDLIntermediateNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:24'!
getCycleComponentDefinitionClass

	^BpmIntermediateComponentDefinition! !

!XPDLTaskNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/28/2015 12:16'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getTaskNamed: self getName ifNone: [nil]! !

!XPDLTaskNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 12/13/2015 13:56'!
getBpmClass

	self extendedValueOf: 'seasideComponent' ifAbsent: [^BpmOrbeonTaskDefinition].
	
	^BpmSeasideTaskDefinition! !

!XPDLEndNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 08/06/2016 15:01'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getEndEventNamed: self getName ifNone: [nil]! !

!XPDLEndNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:28'!
getCycleComponentDefinitionClass

	^BpmEndComponentDefinition! !

!XPDLTransitionNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 09/11/2016 14:04'!
createBpmDefinitionOn: aBpmProcessDefinition

	^(BpmTransitionDefinition process: aBpmProcessDefinition)
		name: self getName;
		setCondition: startCondition;
		isDefaultFlow: isDefaultFlow;
		yourself! !

!XPDLScriptNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 06/24/2016 09:49'!
createBpmDefinitionOn: aBpmProcessDefinition
	"The receiver answer a sub instance of <BpmArtifactDefinition> that represent the XPDL element (the receiver) in the BPM model"
	| activityDefinition | 

	activityDefinition := super createBpmDefinitionOn: aBpmProcessDefinition.

	activityDefinition scriptCode: script.

	^activityDefinition! !

!XPDLScriptNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 06/22/2016 11:03'!
getBpmClass

	^BpmScriptTaskDefinition! !

!XPDLActivityNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/05/2017 09:19'!
createBpmDefinitionOn: aBpmProcessDefinition
	"The receiver answer a sub instance of <BpmArtifactDefinition> that represent the XPDL element (the receiver) in the BPM model"
	| loop activityDefinition |

	activityDefinition := (self getBpmClass process: aBpmProcessDefinition)
		name: self getName;
		yourself.

	loop := self getLoopTypeClass for: activityDefinition.
	loop startQuantity: self getStartQuantity;
		completionQuantity: self getCompletionQuantity;
		setLoop: loopCondition.

	^activityDefinition loop: loop! !

!XPDLActivityNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/05/2017 09:19'!
getBpmClass

	^self subclassResponsibility! !

!XPDLActivityNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/05/2017 09:19'!
getLoopTypeClass

	(loopType = 'Standard') ifTrue: [^BpmStandartTaskLoop].

	(loopType = 'MultiInstance') ifTrue: [^BpmMultiInstanceTaskLoop].

	(loopType = 'None') ifTrue: [^BpmNoneTaskLoop].

	^BpmNoneTaskLoop! !

!XPDLEventNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:28'!
createBpmDefinitionOn: aBpmProcessDefinition
	| event |

	event := BpmEventDefinition process: aBpmProcessDefinition.
	event name: self getName;
		cycle: (self getCycleComponentDefinitionClass event: event);
		type: (self getBpmTypeComponentDefinitionClass event: event);
		tag: (self getBpmTagComponentDefinitionClass event: event);
		yourself.

	^event! !

!XPDLEventNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:26'!
getBpmTagComponentDefinitionClass

	^BpmNormalTagComponentDefinition! !

!XPDLEventNode methodsFor: '*orbeonBPMXpdl' stamp: 'brunobb 10/16/2017 07:32'!
getBpmTypeComponentDefinitionClass

	self isTimerNode ifFalse: [^BpmNoneComponentDefinition].

	^BpmTimerComponentDefinition! !

!XPDLEventNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 03/12/2017 15:26'!
getCycleComponentDefinitionClass

	self subclassResponsibility! !

Object subclass: #BpmProcessGenerator
	instanceVariableNames: 'xpdlPackages processes participants processesMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl'!

BpmProcessGenerator subclass: #BpmBizagiProcessGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMXpdl'!

!BpmProcessGenerator class methodsFor: 'example' stamp: 'BrunoBB 06/27/2016 11:35'!
exampleEmbeddedSubProcSubProc
	| generator reader |

	reader:= XPDLProcessDefinitionTemplate xpdlReaderForEmbeddedEmbeddedProcess.

	generator := self on: reader xpdlPackages.

	generator 
		mapProcess: 'multi-embedded' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		generateAllProcess.

	^generator! !

!BpmProcessGenerator class methodsFor: 'example' stamp: 'BrunoBB 06/25/2016 14:51'!
exampleTestCaseEmbeddedSubProc
	| generator reader |

	reader:= XPDLProcessDefinitionTemplate xpdlReaderForReusableEmbeddedProcess.

	generator := self on: reader xpdlPackages.

	generator 
		mapProcess: 'ReusableEmbeddedProc' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		mapProcess: 'Reusable-Script' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		generateAllProcess.

	^generator! !

!BpmProcessGenerator class methodsFor: 'example' stamp: 'BrunoBB 04/01/2016 15:13'!
exampleTestCaseFixIssueReportArchitect
	| generator |

	generator := self on: (XPDLReader2 exampleMultipleProcesses) xpdlPackages.

	generator 
		mapProcess: 'test-case-process' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		mapProcess: 'fix-issue' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		mapProcess: 'architect-process' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		generateAllProcess.

	^generator! !

!BpmProcessGenerator class methodsFor: 'example' stamp: 'brunobb 10/15/2017 19:44'!
exampleTestCaseProcessWithScript
	| generator reader |

	reader:=  (XPDLReader2 forProcessNamed: 'Process with Scripts' withString: XPDLProcessDefinitionTemplate xpdlExample_process_with_script)
				connectProcesses; 
				yourself.

	generator := self on: reader xpdlPackages.

	generator 
		mapProcess: 'Process with Scripts' toApplication: (self getApplicationManagerClass getAnyApplicationNamed: 'ue');
		generateAllProcess.

	^generator! !

!BpmProcessGenerator class methodsFor: 'instance creation' stamp: 'BrunoBB 10/31/2015 15:57'!
on: collectionOfXPDLPackages

	^super new initialize
		xpdlPackages: collectionOfXPDLPackages;
		yourself! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'brunobb 10/18/2017 12:57'!
attachEventsToTaskIn: aBpmProcessDefinition withXPDL: aXPDLWorflowProcess
	"The receiver attach events to tasks in <aBpmProcessDefinition> as is defined in xpdl process <aXPDLWorflowProcess>"

	aBpmProcessDefinition getTasks do: [:taskDefinition | | xpdlElement |
		xpdlElement := aXPDLWorflowProcess getTaskNamed: taskDefinition name ifNone: [].
		xpdlElement attachedEvents do: [:eventNode | | bpmEvent |
			bpmEvent := aBpmProcessDefinition getIntermediateEventNamed: eventNode getName ifNone: [].
			taskDefinition attachEvent: bpmEvent.
		]. 
	].! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 06/29/2016 09:35'!
connectSubProcessTaskWithSubProcess
	"The receiver connect all sub process tasks <BpmSubProcessTaskDefinition> with the related process definition <BpmProcessDefinition>"
	| subProcessTasks |

	subProcessTasks := OrderedCollection new.

	processes do: [:procDefinition | 
		procDefinition getSubProcessTasks do: [:subProcTaskDefinition | | subProcess |
			subProcess := subProcTaskDefinition isEmbedded
					ifFalse: [processes detect: [:each | each sheetName = subProcTaskDefinition name] ifNone:  [nil]]
					ifTrue: [| subProc |
						processes do: [:each | (each getSubProcessNamed: subProcTaskDefinition name ifAbsent: [nil]) ifNotNil: [:value | subProc := value]].
						subProc].
			subProcTaskDefinition setSubProcessDefinition: subProcess.
			subProcessTasks add: subProcTaskDefinition.
		].
	].
	subProcessTasks do: [:each | each setRolesOfUnderlineProcess] "set roles for embedded processes -that has no Lanes-"! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 07/07/2016 07:59'!
createEmbeddedSubProcessFor: aBpmProcessDefinition basedOn: xpdlPool package: xpdlPackage
	"The receiver create all embedded sub process of <aBpmProcessDefinition> in pool <xpdlPool> and package <xpdlPackage>.
	It support recursive sub processes of deep N"
	| embedded |

	embedded := OrderedCollection new.
	xpdlPool getAllEmbbeddedProcesses do: [:eachWorkflow | | newSubProcDefinition |
		newSubProcDefinition := (self getProcessDefinitionClassFrom: eachWorkflow) newNamed: eachWorkflow getName.
		newSubProcDefinition sheetName: eachWorkflow getSheetName.
		self populateBpmDefinition: newSubProcDefinition withXPDL: eachWorkflow for: aBpmProcessDefinition application.
		newSubProcDefinition isEmbedded: true.
		newSubProcDefinition xmlString: xpdlPackage prettyPrinted.
		processes at: newSubProcDefinition processName put: newSubProcDefinition.
		embedded add: (Array with: eachWorkflow with: newSubProcDefinition).
	].

	embedded do: [:eachFirst | "connect embedded process with it's subprocess (first: workflow, second: BpmSubProcDefinition)"
		embedded do: [:eachSecond | 
			(eachFirst == eachSecond)
			ifFalse: [(eachFirst first parentWorkflow == eachSecond first)
						ifTrue:[eachSecond second addSubProcess: eachFirst second].
						(eachSecond first parentWorkflow == eachFirst first)
						ifTrue:[eachFirst second addSubProcess: eachSecond second]
			].
		].
	].
	((embedded collect: [:each | each second]) "collect process definition"
		select: [:each | each parentProcess isNil])  "sub process with not parent --> the parent is the top parent"
			do: [:each | aBpmProcessDefinition addSubProcess: each].! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 11/01/2015 08:19'!
createParticipantDefinitionsOf: aXPDLPackageNode
	"The receiver create the GLOBAL participants <BpmParticipantDefinition> for all processes to be imported"

	aXPDLPackageNode participants do: [:participantNode |
		participants add: participantNode createBpmDefinition]! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 06/27/2016 10:21'!
generateAllProcess
	"The receiver creates all Processes from <xpdlPackages>.
	1- Create the GLOBAL Participants for all processes.
	2- Create one process <BpmProcessDefinition> per each pool <XPDLPoolNode> in all packages <XPDLPackageNode>
	3- Connect all sub processes node <BpmSubProcessTaskDefinition> with the concrete processes definitions <BpmProcessDefinition>"

	xpdlPackages isEmpty ifTrue: [^self].

	self createParticipantDefinitionsOf: xpdlPackages asArray first. "participants are GLOBAL to all sheets in a Bizagi model with subprocesses"

	xpdlPackages do: [:eachPackage | 
		eachPackage pools do: [:each | | newProcess |
			newProcess := self generateProcessBasedOnWorkflow: each workflow.
			newProcess xmlString: eachPackage prettyPrinted. "set the XML string of the process"
			processes at: newProcess processName put: newProcess.
			self createEmbeddedSubProcessFor: newProcess basedOn: each package: eachPackage."create the embedded hierarchy"
		].
	].
	self connectSubProcessTaskWithSubProcess. "connect sub process task  artifacts with process definitions"

	^processes! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 06/26/2016 13:47'!
generateProcessBasedOnWorkflow: aXPDLWorflowProcess
	"The receiver creates BPM process definition <BpmProcessDefinition> based on the XPDL pool <aXPDLPool>"
	| processDefinition application |

	processDefinition := (self getProcessDefinitionClassFrom: aXPDLWorflowProcess) newNamed: aXPDLWorflowProcess getName.
	processDefinition sheetName: aXPDLWorflowProcess getSheetName.

	application := processesMapping at: processDefinition processName ifAbsent: [self throwMappingExceptionFor: processDefinition processName].

	^self populateBpmDefinition: processDefinition withXPDL: aXPDLWorflowProcess for: application! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 06/26/2016 13:47'!
generateProcessBasedOnWorkflow: aXPDLWorflowProcess for: anOrbeonApplication
	"The receiver creates BPM process definition <BpmProcessDefinition> based on the XPDL pool <aXPDLPool>"
	"The receiver creates BPM process definition <BpmProcessDefinition> based on the XPDL pool <aXPDLPool>"
	| processDefinition |

	processDefinition := (self getProcessDefinitionClassFrom: aXPDLWorflowProcess) newNamed: aXPDLWorflowProcess getName.
	processDefinition sheetName: aXPDLWorflowProcess getSheetName.

	^self populateBpmDefinition: processDefinition withXPDL: aXPDLWorflowProcess for: anOrbeonApplication! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 06/26/2016 13:32'!
getProcessDefinitionClassFrom: aXPDLPool
	"Answer the correct process definition for xpdl element <aXPDLPool>"

	^aXPDLPool hasParentProcess
		ifFalse: [BpmTopProcessDefinition]
		ifTrue: [BpmSubProcessDefinition]! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 10/29/2015 13:53'!
getProcessDefinitionNamed: aString ifNone: aBlock

	^processes at: aString ifAbsent: aBlock! !

!BpmProcessGenerator methodsFor: 'other' stamp: 'BrunoBB 11/22/2015 14:28'!
initialize

	super initialize.

	processes := Dictionary new.
	participants := OrderedCollection new.
	processesMapping := Dictionary new. "each key is a process name and each value is a valid OrbeonApplication name"! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'BrunoBB 12/09/2015 11:17'!
mapProcess: procNamed toApplication: anOrbeonApplication
	"The receiver map the BpmProcessDefinition named <procNamed> with the <OrbeonApplication> named <appName>"

	^processesMapping at: procNamed put: anOrbeonApplication! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 16:29'!
participants
	^participants! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 16:29'!
participants: newValue
	participants := newValue! !

!BpmProcessGenerator methodsFor: 'process definition creation' stamp: 'brunobb 02/03/2018 09:53'!
populateBpmDefinition: aBpmProcessDefinition withXPDL: aXPDLWorflowProcess for: anOrbeonApplication
	"The receiver creates BPM process definition <BpmProcessDefinition> based on the XPDL pool <aXPDLPool>"
	| roles |

	aBpmProcessDefinition application: anOrbeonApplication.
	aBpmProcessDefinition addAllParticipants: participants.
	roles := Dictionary new.

	aXPDLWorflowProcess parentLanes keysDo: [:laneName | | newOrExistingRole |
		newOrExistingRole := BpmFrontOfficeRole createNewOrGetExisting: laneName in: anOrbeonApplication applicationName.
		aBpmProcessDefinition addRole: newOrExistingRole.
		roles at: laneName put: newOrExistingRole.
	].

	"it create the corresponding Bpm definition for each Xpdl artifact <xpdlActivity> in the pool <aXPDLPool>"
	aXPDLWorflowProcess activities do: [:xpdlActivity | | newArtifact lanesNames |
		newArtifact := xpdlActivity createBpmDefinitionOn: aBpmProcessDefinition.
		xpdlActivity performers do: [:eachParticipantNode | | bpmPerformer performerRole | "here the Performers of the task are set"
			bpmPerformer :=  participants detect: [:each | each name = eachParticipantNode getName].
			performerRole := BpmFrontOfficeRole createNewOrGetExisting: bpmPerformer name in: anOrbeonApplication applicationName."create the role for the performer"
			newArtifact addPerformer: bpmPerformer;
				grantRole: performerRole]. "grant the role of the performer to the task definition"
		newArtifact addToParentProcess.
		newArtifact setExtendedAttributesWith: xpdlActivity extendedAttributes.
		xpdlActivity performers ifEmpty: ["if has perfomers --> lanes roles are NOT granted to the task (only performers roles are granted)"
			lanesNames := (xpdlActivity getLanesFrom: aXPDLWorflowProcess) collect: [:each | each getName].
			lanesNames do: [:laneName | (roles at: laneName ifAbsent: [nil]) ifNotNil: [:rol | newArtifact grantRole: rol]]
		]
	].
	aXPDLWorflowProcess transitions collect: [:xpdlTransition | | newTransition |
		newTransition := (xpdlTransition createBpmDefinitionOn: aBpmProcessDefinition) addToParentProcess.
		newTransition extendedAttributes: xpdlTransition extendedAttributes.
		newTransition setStartArtifact: (xpdlTransition startNode getArtifactFrom: aBpmProcessDefinition).
		newTransition setEndArtifact: (xpdlTransition endNode getArtifactFrom: aBpmProcessDefinition).
	].

	"the receiver attach events to task. At this point both exist but are unrelated "
	self attachEventsToTaskIn: aBpmProcessDefinition withXPDL: aXPDLWorflowProcess.

	^aBpmProcessDefinition! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 10/26/2015 17:48'!
processes
	^processes! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 10/26/2015 17:48'!
processes: newValue
	processes := newValue! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 12:34'!
processesMapping
	^processesMapping! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 12:34'!
processesMapping: newValue
	processesMapping := newValue! !

!BpmProcessGenerator methodsFor: 'other' stamp: 'BrunoBB 03/29/2016 15:27'!
throwMappingExceptionFor: aString

	^ProcessAppMappingException signal: 'Failed to map process [', aString, '] because the mapping dictionary <processesMapping> does NOT includes the stated Application'! !

!BpmProcessGenerator methodsFor: 'Accessing' stamp: 'BrunoBB 10/31/2015 15:54'!
xpdlPackages
	^xpdlPackages! !

!BpmProcessGenerator methodsFor: 'Updating' stamp: 'BrunoBB 10/31/2015 15:54'!
xpdlPackages: newValue
	xpdlPackages := newValue! !

!XPDLGatewayNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/30/2015 14:14'!
createBpmDefinitionOn: aBpmProcessDefinition

	^(self getGatewayClass process: aBpmProcessDefinition)
		name: self getName;
		yourself! !

!XPDLGatewayNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/28/2015 12:15'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getGatewayNamed: self getName ifNone: [nil]! !

!XPDLGatewayNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 10/30/2015 14:15'!
getGatewayClass

	(type = 'Parallel') ifTrue: [^BpmParallelGatewayDefinition].

	(type = 'Inclusive') ifTrue: [^BpmInclusiveGatewayDefinition].

	(type = 'Complex') ifTrue: [^BpmComplexGatewayDefinition].

	^BpmExclusiveGatewayDefinition! !

!XPDLSubProcessNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 06/26/2016 14:06'!
getArtifactFrom: aBpmProcessDefinition

	^aBpmProcessDefinition getSubProcessTaskNamed: self getName ifNone: [nil]! !

!XPDLSubProcessNode methodsFor: '*orbeonBPMXpdl' stamp: 'BrunoBB 06/26/2016 14:40'!
getBpmClass

	^BpmSubProcessTaskDefinition! !
